"use strict";(self.webpackChunkwaveterm_docs=self.webpackChunkwaveterm_docs||[]).push([[660],{6968:(e,t,n)=>{n.r(t),n.d(t,{assets:()=>a,contentTitle:()=>d,default:()=>l,frontMatter:()=>c,metadata:()=>s,toc:()=>r});const s=JSON.parse('{"id":"connections","title":"Connections","description":"Wave allows users to connect to various machines and unify them together in a way that preserves the unique behavior of each. At the moment, this extends to SSH remote connections and local WSL connections.","source":"@site/docs/connections.mdx","sourceDirName":".","slug":"/connections","permalink":"/docsite/connections","draft":false,"unlisted":false,"tags":[],"version":"current","sidebarPosition":7,"frontMatter":{"sidebar_position":7,"id":"connections","title":"Connections"},"sidebar":"defaultSidebar","previous":{"title":"Custom Widgets","permalink":"/docsite/customwidgets"},"next":{"title":"Telemetry","permalink":"/docsite/telemetry"}}');var i=n(2540),o=n(3023);const c={sidebar_position:7,id:"connections",title:"Connections"},d="Connections",a={},r=[{value:"Access a Connection in a Block",id:"access-a-connection-in-a-block",level:2},{value:"What are wsh Shell Extensions?",id:"what-are-wsh-shell-extensions",level:2},{value:"Add a New Connection to the Dropdown",id:"add-a-new-connection-to-the-dropdown",level:2},{value:"SSH Config Parsing",id:"ssh-config-parsing",level:2},{value:"Example SSH Config Host",id:"example-ssh-config-host",level:3},{value:"Managing Connections with the CLI",id:"managing-connections-with-the-cli",level:2}];function h(e){const t={a:"a",code:"code",h1:"h1",h2:"h2",h3:"h3",header:"header",img:"img",p:"p",pre:"pre",table:"table",tbody:"tbody",td:"td",th:"th",thead:"thead",tr:"tr",...(0,o.R)(),...e.components};return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsx)(t.header,{children:(0,i.jsx)(t.h1,{id:"connections",children:"Connections"})}),"\n",(0,i.jsx)(t.p,{children:"Wave allows users to connect to various machines and unify them together in a way that preserves the unique behavior of each. At the moment, this extends to SSH remote connections and local WSL connections."}),"\n",(0,i.jsx)(t.h2,{id:"access-a-connection-in-a-block",children:"Access a Connection in a Block"}),"\n",(0,i.jsxs)(t.p,{children:["The easiest way to access connections is to click the ",(0,i.jsx)("i",{className:"fa-sharp fa-laptop"})," icon. From there, you can either type ",(0,i.jsx)(t.code,{children:"[user]@[host]"})," for a desired SSH remote or type ",(0,i.jsx)(t.code,{children:"wsl://<distribution name>"})," for a desired WSL distribution. Alternatively, if the connection already exists in the dropdown list, you can either click it or navigate to it with arrow keys and press enter to connect."]}),"\n",(0,i.jsx)(t.p,{children:(0,i.jsx)(t.img,{alt:"a dropdown showing a list of connections that already exist",src:n(2571).A+"",width:"1316",height:"1038"})}),"\n",(0,i.jsx)(t.h2,{id:"what-are-wsh-shell-extensions",children:"What are wsh Shell Extensions?"}),"\n",(0,i.jsxs)(t.p,{children:[(0,i.jsx)(t.code,{children:"wsh"})," is a small program that helps manage waveterm regardless of which machine you are currently connected to. In order to not interrupt the normal flow of the remote session, we install it on your remote machine at ",(0,i.jsx)(t.code,{children:"~/.waveterm/bin/wsh"}),". Then, when wave connects to your connection (and only when wave connects to your connection), ",(0,i.jsx)(t.code,{children:"~/.waveterm/bin"})," is added to your ",(0,i.jsx)(t.code,{children:"PATH"})," for that individual session. For more info on what ",(0,i.jsx)(t.code,{children:"wsh"})," is capable of, see ",(0,i.jsx)(t.a,{href:"/wsh",children:"wsh command"}),". And if you wish to view the source code of ",(0,i.jsx)(t.code,{children:"wsh"}),", you can find it ",(0,i.jsx)(t.a,{href:"https://github.com/wavetermdev/waveterm/tree/main/cmd/wsh",children:"here"}),"."]}),"\n",(0,i.jsx)(t.h2,{id:"add-a-new-connection-to-the-dropdown",children:"Add a New Connection to the Dropdown"}),"\n",(0,i.jsxs)(t.p,{children:["The SSH values that are loaded into the dropdown by default are obtained by parsing your ",(0,i.jsx)(t.code,{children:"~/.ssh/config"})," and ",(0,i.jsx)(t.code,{children:"/etc/ssh/ssh_config"})," files. Adding a new connection is as simple as adding a new ",(0,i.jsx)(t.code,{children:"Host"})," to one of these files, typically the ",(0,i.jsx)(t.code,{children:"~/.ssh/config"})," file."]}),"\n",(0,i.jsx)(t.p,{children:"WSL values are added by searching the installed WSL distributions as they appear in the Windows Registry."}),"\n",(0,i.jsx)(t.h2,{id:"ssh-config-parsing",children:"SSH Config Parsing"}),"\n",(0,i.jsxs)(t.p,{children:["At the moment, we are capable of parsing any SSH config file that does not contain the ",(0,i.jsx)(t.code,{children:"Match"})," keyword. This keyword is incompatible with a library we are using, but we are hoping to fix that soon. While all other valid keywords are parsed, we only support the functionality of a small subset of them at the moment:"]}),"\n",(0,i.jsxs)(t.table,{children:[(0,i.jsx)(t.thead,{children:(0,i.jsxs)(t.tr,{children:[(0,i.jsx)(t.th,{children:"Keyword"}),(0,i.jsx)(t.th,{children:"Description"})]})}),(0,i.jsxs)(t.tbody,{children:[(0,i.jsxs)(t.tr,{children:[(0,i.jsx)(t.td,{children:"Host"}),(0,i.jsxs)(t.td,{children:["The pattern to match when attempting to connect via ",(0,i.jsx)(t.code,{children:"[user]@[host]"}),". We list hosts that do not contain any wildcards characters (",(0,i.jsx)(t.code,{children:"*"}),", ",(0,i.jsx)(t.code,{children:"?"}),", or ",(0,i.jsx)(t.code,{children:"!"}),"). Even if a host pattern contains wildcards, it will still be parsed when determining the values associated with the keys as usual."]})]}),(0,i.jsxs)(t.tr,{children:[(0,i.jsx)(t.td,{children:"User"}),(0,i.jsx)(t.td,{children:"The user of the SSH remote connection. This will default to the current user on the local machine if not specified."})]}),(0,i.jsxs)(t.tr,{children:[(0,i.jsx)(t.td,{children:"Port"}),(0,i.jsxs)(t.td,{children:["The port to connect to the remote on. ",(0,i.jsx)(t.code,{children:"22"})," is the default if not specified."]})]}),(0,i.jsxs)(t.tr,{children:[(0,i.jsx)(t.td,{children:"IdentityFile"}),(0,i.jsx)(t.td,{children:"This can be specified more than once per host. It gives the path to a private identity file (id_rsa, id_ed25519, id_ecdsa, etc.) that is used to authenticate the connection. Each will be tried in order, and they can be encrypted with a passphrase if desired. If no value is set, the default is to try in order: ~/.ssh/id_rsa, ~/.ssh/id_ecdsa, ~/.ssh/id_ecdsa_sk, ~/.ssh/id_ed25519_sk, ~/.ssh/id_dsa."})]}),(0,i.jsxs)(t.tr,{children:[(0,i.jsx)(t.td,{children:"BatchMode"}),(0,i.jsx)(t.td,{children:"If set to true, user interaction via password, challenge/response, and publickey passphrase authentication will be disabled. It is set to false by default."})]}),(0,i.jsxs)(t.tr,{children:[(0,i.jsx)(t.td,{children:"PubkeyAuthentication"}),(0,i.jsxs)(t.td,{children:["(partial) This is used to specify if pubkey authentication should be attempted. It is partially implementented as the ",(0,i.jsx)(t.code,{children:"unbound"})," and ",(0,i.jsx)(t.code,{children:"host-bound"})," values simply work the same as the ",(0,i.jsx)(t.code,{children:"yes"})," value. The default is ",(0,i.jsx)(t.code,{children:"yes"}),"."]})]}),(0,i.jsxs)(t.tr,{children:[(0,i.jsx)(t.td,{children:"PasswordAuthentication"}),(0,i.jsxs)(t.td,{children:["This is used to specify if password authentication should be attempted. The default is ",(0,i.jsx)(t.code,{children:"yes"}),"."]})]}),(0,i.jsxs)(t.tr,{children:[(0,i.jsx)(t.td,{children:"KbdInteractiveAuthentication"}),(0,i.jsxs)(t.td,{children:["This is used to specify if keyboard-interactive authentication should be attempted. The default is ",(0,i.jsx)(t.code,{children:"yes"}),"."]})]}),(0,i.jsxs)(t.tr,{children:[(0,i.jsx)(t.td,{children:"PreferredAuthentications"}),(0,i.jsxs)(t.td,{children:["(partial) Specifies the order the client should attempt to authenticate in. It is partially implemented as it does not support ",(0,i.jsx)(t.code,{children:"gssapi-with-mic"})," or ",(0,i.jsx)(t.code,{children:"hostbased"})," authentication. The default is ",(0,i.jsx)(t.code,{children:"publickey,keyboard-interactive,password"})]})]}),(0,i.jsxs)(t.tr,{children:[(0,i.jsx)(t.td,{children:"AddKeysToAgent"}),(0,i.jsxs)(t.td,{children:["(partial) This option will automatically add keys and their corresponding passphrase to your running ssh agent if it is enabled. It is partially supported as it can only accept ",(0,i.jsx)(t.code,{children:"yes"})," and ",(0,i.jsx)(t.code,{children:"no"})," as valid inputs. Other inputs such as ",(0,i.jsx)(t.code,{children:"confirm"})," or a time interval will behave the same as ",(0,i.jsx)(t.code,{children:"no"}),". The default value is ",(0,i.jsx)(t.code,{children:"no"}),"."]})]}),(0,i.jsxs)(t.tr,{children:[(0,i.jsx)(t.td,{children:"ProxyJump"}),(0,i.jsxs)(t.td,{children:["Specifies one or more jump proxies in a comma separated list. Each will be visited sequentially using TCP forwarding before connecting to the desired connection (also using TCP forwarding). It can be set to ",(0,i.jsx)(t.code,{children:"none"})," to disable the feature."]})]})]})]}),"\n",(0,i.jsx)(t.h3,{id:"example-ssh-config-host",children:"Example SSH Config Host"}),"\n",(0,i.jsx)(t.p,{children:"For a quick example, a host in your config file may look like:"}),"\n",(0,i.jsx)(t.pre,{children:(0,i.jsx)(t.code,{children:"Host myhost\n   User username\n   HostName 203.0.113.254\n   IdentityFile ~/.ssh/id_rsa\n   AddKeysToAgent yes\n"})}),"\n",(0,i.jsxs)(t.p,{children:["You would then be able to access this connection with ",(0,i.jsx)(t.code,{children:"myhost"})," or ",(0,i.jsx)(t.code,{children:"username@myhost"}),". And if you wanted to manually specify a port such as port 2222, you could do that by either adding ",(0,i.jsx)(t.code,{children:"Port 2222"})," to the config file or connecting to ",(0,i.jsx)(t.code,{children:"username@myhost:2222"}),"."]}),"\n",(0,i.jsx)(t.h2,{id:"managing-connections-with-the-cli",children:"Managing Connections with the CLI"}),"\n",(0,i.jsxs)(t.p,{children:["The ",(0,i.jsx)(t.code,{children:"wsh"})," command gives some commands specifically for interacting with the connections. You can view these ",(0,i.jsx)(t.a,{href:"/wsh#conn",children:"here"}),"."]})]})}function l(e={}){const{wrapper:t}={...(0,o.R)(),...e.components};return t?(0,i.jsx)(t,{...e,children:(0,i.jsx)(h,{...e})}):h(e)}},2571:(e,t,n)=>{n.d(t,{A:()=>s});const s=n.p+"assets/images/connection-dropdown-1ef30ec5e9fbaaa1a11dfac4ce39036b.png"},3023:(e,t,n)=>{n.d(t,{R:()=>c,x:()=>d});var s=n(3696);const i={},o=s.createContext(i);function c(e){const t=s.useContext(o);return s.useMemo((function(){return"function"==typeof e?e(t):{...t,...e}}),[t,e])}function d(e){let t;return t=e.disableParentContext?"function"==typeof e.components?e.components(i):e.components||i:c(e.components),s.createElement(o.Provider,{value:t},e.children)}}}]);