"use strict";(self.webpackChunkwaveterm_docs=self.webpackChunkwaveterm_docs||[]).push([[509],{6608:(e,t,o)=>{o.r(t),o.d(t,{assets:()=>d,contentTitle:()=>c,default:()=>g,frontMatter:()=>r,metadata:()=>i,toc:()=>h});const i=JSON.parse('{"id":"layout","title":"Tab Layout System","description":"screenshot showing a block being dragged over another block, with the placeholder depicting a out-of-line before outer drop","source":"@site/docs/layout.mdx","sourceDirName":".","slug":"/layout","permalink":"/docsite/layout","draft":false,"unlisted":false,"tags":[],"version":"current","sidebarPosition":2,"frontMatter":{"sidebar_position":2,"id":"layout","title":"Tab Layout System"},"sidebar":"defaultSidebar","previous":{"title":"Key Bindings","permalink":"/docsite/keybindings"},"next":{"title":"Configuration","permalink":"/docsite/config"}}');var n=o(2540),l=o(3023),a=o(1341),s=o(7982);const r={sidebar_position:2,id:"layout",title:"Tab Layout System"},c=void 0,d={},h=[{value:"Layout system under the hood",id:"layout-system-under-the-hood",level:2},{value:"Layout actions",id:"layout-actions",level:2},{value:"Add a new block",id:"add-a-new-block",level:3},{value:"Delete a block",id:"delete-a-block",level:3},{value:"Move a block",id:"move-a-block",level:3},{value:"Possible block movements",id:"possible-block-movements",level:4},{value:"Resize a block",id:"resize-a-block",level:3},{value:"Change the gap size between blocks",id:"change-the-gap-size-between-blocks",level:2}];function b(e){const t={a:"a",admonition:"admonition",code:"code",h2:"h2",h3:"h3",h4:"h4",img:"img",li:"li",ol:"ol",p:"p",strong:"strong",ul:"ul",...(0,l.R)(),...e.components};return(0,n.jsxs)(a.V9,{children:[(0,n.jsx)(a.WH,{}),(0,n.jsx)(t.p,{children:(0,n.jsx)(t.img,{alt:"screenshot showing a block being dragged over another block, with the placeholder depicting a out-of-line before outer drop",src:o(6598).A+"",width:"3480",height:"1334"})}),(0,n.jsx)(t.h2,{id:"layout-system-under-the-hood",children:"Layout system under the hood"}),(0,n.jsxs)(t.admonition,{type:"info",children:[(0,n.jsx)(t.p,{children:(0,n.jsx)(t.strong,{children:"Definitions"})}),(0,n.jsxs)(t.ul,{children:["\n",(0,n.jsx)(t.li,{children:"Layout tree: the in-memory representation of a tab layout, comprised of nodes"}),"\n",(0,n.jsx)(t.li,{children:"Node: An entry in the layout tree, either a single block (a leaf) or an ordered list of nodes. Defines a tiling direction (row or column) and a unitless size"}),"\n",(0,n.jsx)(t.li,{children:"Block: The contents of a leaf in the layout tree, defines what contents is displayed at the given layout location"}),"\n"]})]}),(0,n.jsxs)(t.p,{children:["Our layout system emulates the ",(0,n.jsx)(t.a,{href:"https://developer.mozilla.org/en-US/docs/Web/CSS/CSS_flexible_box_layout/Basic_concepts_of_flexbox",children:"CSS Flexbox"})," system, comprising of a tree of columns and rows. Under the hood, the layout is represented as an n-tree, where each node in the tree is either a single block, or a list of nodes. Each level in the tree alternates the direction in which it tiles (level 1 tiles as a row, level 2 as a column, level 3 as a row, etc.)."]}),(0,n.jsx)(t.h2,{id:"layout-actions",children:"Layout actions"}),(0,n.jsx)(t.h3,{id:"add-a-new-block",children:"Add a new block"}),(0,n.jsx)(t.p,{children:"You can add new blocks by selecting a widget from the right sidebar."}),(0,n.jsx)(t.p,{children:"Starting at the topmost level of the tree, since the first level tiles as a row, new blocks will be added to the right side of existing blocks. Once there are 5 blocks across, new blocks will begin being added below existing blocks, starting from the right side and working to the left. As a new block gets added below an existing one, the node containing the existing block is converted from a single-block node to a list node and the existing block definition is moved one level deeper in the tree as the first element of the node list. New blocks will always be added to the last-available node in the deepest level, where available is defined as having less than five children. We don't set a limit on the number of blocks in a tab, but you may experience degraded performance past around 25 blocks."}),(0,n.jsx)(t.p,{children:"While we define a 5-child limit for each node in the tree when automatically placing new blocks, there is no actual limit to the number of children a node can hold. After the block is placed, you are free to move it wherever in the layout"}),(0,n.jsx)(t.h3,{id:"delete-a-block",children:"Delete a block"}),(0,n.jsxs)(t.p,{children:["You can delete blocks by clicking the ",(0,n.jsx)("i",{className:"fa-sharp fa-xmark-large"}),' button in the top-right corner of the block, by right-clicking on the block header and selecting "Close Block" from the context menu, or by running the ',(0,n.jsxs)(t.a,{href:"./wsh#deleteblock",children:[(0,n.jsx)(t.code,{children:"wsh deleteblock"})," command"]}),". Alternatively, the currently focused block/widget can be closed by pressing ",(0,n.jsx)(s.u,{k:"Cmd:w"})]}),(0,n.jsx)(t.p,{children:"When you delete a block, the layout tree will be automatically adjusted to minimize the tree depth."}),(0,n.jsx)(t.h3,{id:"move-a-block",children:"Move a block"}),(0,n.jsx)(t.p,{children:"You can move blocks by clicking on the block header and dragging the block around the tab. You will see placeholders appear to show where the block will land when you drop it."}),(0,n.jsx)(t.p,{children:"There are 7 different drop targets for any given block. A block is divided into quadrants along its diagonals. If the block is tiling as a row (left-to-right), dropping a block into the left or right quadrant will place the dropped block in the same level as the targeted block. This can be considered dropping the block inline. If you drop the block out of line (in quadrants corresponding to opposite tiling direction), the block will either be placed one level above or one level below the targeted block. Dropping the block towards the outside will place it in the same level as the target block's parent, while dropping it towards the center of the block will create a new level, where both the target block and the dropped block will be moved. The middle fifth of the block is reserved for the swap action. Dropping a block here will cause the target block and the dropped block to swap positions in the layout."}),(0,n.jsx)(t.p,{children:(0,n.jsx)(t.img,{alt:"screenshot showing a block being dragged over another block, with the placeholder depicting a swap movement",src:o(2040).A+"",width:"3480",height:"1334"})}),(0,n.jsx)(t.h4,{id:"possible-block-movements",children:"Possible block movements"}),(0,n.jsx)(t.admonition,{type:"note",children:(0,n.jsx)(t.p,{children:"All block movements except for Swap will cause the rest of the layout to shift to accommodate the block's new displacement."})}),(0,n.jsx)(t.p,{children:(0,n.jsx)(t.img,{alt:"annotated example showing the drop targets within a block",src:o(1603).A+"",width:"1633",height:"935"})}),(0,n.jsxs)(t.ol,{children:["\n",(0,n.jsx)(t.li,{children:"Inline before: Drops the block under the same node as the target block, placing it before the target in the same tiling direction"}),"\n",(0,n.jsx)(t.li,{children:"Inline after: Drops the block under the same node as the target block, placing it after the target in the same tiling direction"}),"\n",(0,n.jsx)(t.li,{children:"Out-of-line before outer: Drops the block before the target block's parent node in the opposite tiling direction"}),"\n",(0,n.jsx)(t.li,{children:"Out-of-line before inner: Segments the target block, creating a new node in the tree. Places the dropped block before the target block in the opposite tiling direction."}),"\n",(0,n.jsx)(t.li,{children:"Out-of-line after inner: Segments the target block, creating a new node in the tree. Places the dropped block after the target block in the opposite tiling direction."}),"\n",(0,n.jsx)(t.li,{children:"Out-of-line after outer: Drops the block after the target block's parent node in the opposite tiling direction"}),"\n",(0,n.jsx)(t.li,{children:"Swap: Swaps the position of the dropped block and the targeted block in the layout, preserving the rest of the layout"}),"\n"]}),(0,n.jsx)(t.h3,{id:"resize-a-block",children:"Resize a block"}),(0,n.jsx)(t.p,{children:(0,n.jsx)(t.img,{alt:"screenshot showing the line that appears when the cursor hovers over the margin of a block, indicating which blocks will be resized by dragging the margin",src:o(2519).A+"",width:"1740",height:"1040"})}),(0,n.jsxs)(t.p,{children:["You do not directly resize a block. Rather, you resize the nodes containing the blocks. If you hover your mouse over the margin of a block, you will see the cursor change to ",(0,n.jsx)("i",{className:"fa-sharp fa-arrows-left-right"})," or ",(0,n.jsx)("i",{className:"fa-sharp fa-arrows-up-down"})," to indicate the direction the node can be resized. You will also see a line appear after 500ms to show you how many blocks will be resized by moving that margin. Clicking and dragging on this margin will cause the block(s) to get resized."]}),(0,n.jsx)(t.p,{children:"Node sizes are unitless values. The ratio of all node sizes at a given tree level determines the displacement of each node. If you move a block and its node is deleted, the other nodes at the given tree level will adjust their sizes to account for the new size ratio."}),(0,n.jsx)(t.h2,{id:"change-the-gap-size-between-blocks",children:"Change the gap size between blocks"}),(0,n.jsxs)(t.p,{children:["The gap between blocks defaults to 3px, but this value can be changed by modifying the ",(0,n.jsx)(t.code,{children:"window:tilegapsize"})," configuration value. See ",(0,n.jsx)(t.a,{href:"./config",children:"Configuration"})," for more information on how to change configuration values."]})]})}function g(e={}){const{wrapper:t}={...(0,l.R)(),...e.components};return t?(0,n.jsx)(t,{...e,children:(0,n.jsx)(b,{...e})}):b(e)}},7982:(e,t,o)=>{o.d(t,{u:()=>r});var i=o(7773),n=o(3696),l=o(1341),a=o(2540);const s=e=>{let{k:t}=e;const{platform:o}=(0,n.useContext)(l.rP),i=t.split(":").map(((e,t)=>{const[i,n,l]=function(e,t){return"Arrows"==t?[(0,a.jsx)("span",{className:"spaced",children:"\u2191\u2192\u2193\u2190"}),"Arrow Keys",!0]:"ArrowUp"==t?["\u2191","Arrow Up",!0]:"ArrowRight"==t?["\u2192","Arrow Right",!0]:"ArrowDown"==t?["\u2193","Arrow Down",!0]:"ArrowLeft"==t?["\u2190","Arrow Left",!0]:"Cmd"==t?"mac"===e?["\u2318","Command",!0]:["Alt","Alt",!1]:"Ctrl"==t?["\u2303","Control",!0]:"Shift"==t?["\u21e7","Shift",!0]:"Escape"==t?["Esc",null,!1]:[t,null,!1]}(o,e);return(0,a.jsx)("kbd",{title:n,className:l?"symbol":null,children:i},t)}));return(0,a.jsx)("div",{className:"kbd-group",children:i})},r=e=>{let{k:t}=e;return(0,a.jsx)(i.A,{fallback:(0,a.jsx)("kbd",{children:t}),children:()=>(0,a.jsx)(s,{k:t})})}},1341:(e,t,o)=>{o.d(t,{V9:()=>r,WH:()=>d,rP:()=>a});var i=o(7773),n=o(3696),l=o(2540);const a=(0,n.createContext)(void 0),s=e=>{let{children:t}=e;const[o,i]=(0,n.useState)((()=>{const e=localStorage.getItem("platform");return!e||"mac"!==e&&"linux"!==e?/Mac|iPhone|iPad|iPod/.test(navigator.userAgent)?"mac":"linux":e})());return(0,l.jsx)(a.Provider,{value:{platform:o,togglePlatform:()=>{const e="mac"===o?"linux":"mac";i(e),localStorage.setItem("platform",e)}},children:t})},r=e=>{let{children:t}=e;return(0,l.jsx)(i.A,{fallback:(0,l.jsx)("div",{}),children:()=>(0,l.jsx)(s,{children:t})})},c=()=>{const{platform:e,togglePlatform:t}=(()=>{const e=(0,n.useContext)(a);if(!e)throw new Error("usePlatform must be used within a PlatformProvider");return e})();return(0,l.jsxs)("div",{className:"pill-toggle",children:[(0,l.jsx)("button",{className:"pill-option "+("mac"===e?"active":""),onClick:()=>"mac"!==e&&t(),children:"MacOS"}),(0,l.jsx)("button",{className:"pill-option "+("linux"===e?"active":""),onClick:()=>"linux"!==e&&t(),children:"Linux/Windows"})]})},d=()=>(0,l.jsx)(i.A,{fallback:(0,l.jsx)("div",{}),children:()=>(0,l.jsx)(c,{})})},7773:(e,t,o)=>{o.d(t,{A:()=>l});o(3696);var i=o(462),n=o(2540);function l(e){let{children:t,fallback:o}=e;return(0,i.A)()?(0,n.jsx)(n.Fragment,{children:t?.()}):o??null}},1603:(e,t,o)=>{o.d(t,{A:()=>i});const i=o.p+"assets/images/block-drag-example-a708d55a8fae9ecd63aad6c02d81ff38.jpg"},6598:(e,t,o)=>{o.d(t,{A:()=>i});const i=o.p+"assets/images/drag-edge-38a84993f776937ddabd3c0cb4238782.png"},2040:(e,t,o)=>{o.d(t,{A:()=>i});const i=o.p+"assets/images/drag-swap-8b19564c119b3d5620372fa4318e2eb9.png"},2519:(e,t,o)=>{o.d(t,{A:()=>i});const i=o.p+"assets/images/node-resize-c1fe445a3405596d28d0caf42bc63361.png"},3023:(e,t,o)=>{o.d(t,{R:()=>a,x:()=>s});var i=o(3696);const n={},l=i.createContext(n);function a(e){const t=i.useContext(l);return i.useMemo((function(){return"function"==typeof e?e(t):{...t,...e}}),[t,e])}function s(e){let t;return t=e.disableParentContext?"function"==typeof e.components?e.components(n):e.components||n:a(e.components),i.createElement(l.Provider,{value:t},e.children)}}}]);