"use strict";(self.webpackChunkwaveterm_docs=self.webpackChunkwaveterm_docs||[]).push([[11],{678:(e,n,t)=>{t.r(n),t.d(n,{assets:()=>r,contentTitle:()=>l,default:()=>h,frontMatter:()=>a,metadata:()=>s,toc:()=>c});const s=JSON.parse('{"id":"faq","title":"FAQ","description":"How do I set up my own LLM?","source":"@site/docs/faq.mdx","sourceDirName":".","slug":"/faq","permalink":"/docsite/faq","draft":false,"unlisted":false,"tags":[],"version":"current","sidebarPosition":101,"frontMatter":{"sidebar_position":101,"id":"faq","title":"FAQ"},"sidebar":"defaultSidebar","previous":{"title":"Telemetry","permalink":"/docsite/telemetry"},"next":{"title":"Release Notes","permalink":"/docsite/releasenotes"}}');var o=t(2540),i=t(3023);const a={sidebar_position:101,id:"faq",title:"FAQ"},l="FAQ",r={},c=[{value:"How do I set up my own LLM?",id:"how-do-i-set-up-my-own-llm",level:3},{value:"How can I connect to Azure AI?",id:"how-can-i-connect-to-azure-ai",level:3},{value:"How can I connect to Claude?",id:"how-can-i-connect-to-claude",level:3},{value:"How can I see the block numbers?",id:"how-can-i-see-the-block-numbers",level:3},{value:"How do I make a remote connection?",id:"how-do-i-make-a-remote-connection",level:3},{value:"On Windows, how can I use Git Bash as my default shell?",id:"on-windows-how-can-i-use-git-bash-as-my-default-shell",level:3}];function d(e){const n={a:"a",code:"code",h1:"h1",h3:"h3",header:"header",p:"p",pre:"pre",table:"table",tbody:"tbody",td:"td",th:"th",thead:"thead",tr:"tr",...(0,i.R)(),...e.components};return(0,o.jsxs)(o.Fragment,{children:[(0,o.jsx)(n.header,{children:(0,o.jsx)(n.h1,{id:"faq",children:"FAQ"})}),"\n",(0,o.jsx)(n.h3,{id:"how-do-i-set-up-my-own-llm",children:"How do I set up my own LLM?"}),"\n",(0,o.jsxs)(n.p,{children:["Open your ",(0,o.jsx)(n.a,{href:"./config",children:"config file"})," in Wave using ",(0,o.jsx)(n.code,{children:"wsh editconfig"})," (the config file is normally located\nat ",(0,o.jsx)(n.code,{children:"~/.config/waveterm/settings.json"}),")."]}),"\n",(0,o.jsxs)(n.table,{children:[(0,o.jsx)(n.thead,{children:(0,o.jsxs)(n.tr,{children:[(0,o.jsx)(n.th,{children:"Key Name"}),(0,o.jsx)(n.th,{children:"Type"}),(0,o.jsx)(n.th,{children:"Function"})]})}),(0,o.jsxs)(n.tbody,{children:[(0,o.jsxs)(n.tr,{children:[(0,o.jsxs)(n.td,{children:["ai",":baseurl"]}),(0,o.jsx)(n.td,{children:"string"}),(0,o.jsx)(n.td,{children:"Set the AI Base Url (must be OpenAI compatible)"})]}),(0,o.jsxs)(n.tr,{children:[(0,o.jsxs)(n.td,{children:["ai",":apitoken"]}),(0,o.jsx)(n.td,{children:"string"}),(0,o.jsx)(n.td,{children:"your AI api token"})]}),(0,o.jsxs)(n.tr,{children:[(0,o.jsxs)(n.td,{children:["ai",":name"]}),(0,o.jsx)(n.td,{children:"string"}),(0,o.jsx)(n.td,{children:"string to display in the Wave AI block header"})]}),(0,o.jsxs)(n.tr,{children:[(0,o.jsxs)(n.td,{children:["ai",":model"]}),(0,o.jsx)(n.td,{children:"string"}),(0,o.jsx)(n.td,{children:"model name to pass to API"})]}),(0,o.jsxs)(n.tr,{children:[(0,o.jsxs)(n.td,{children:["ai",":maxtokens"]}),(0,o.jsx)(n.td,{children:"int"}),(0,o.jsx)(n.td,{children:"max tokens to pass to API"})]}),(0,o.jsxs)(n.tr,{children:[(0,o.jsxs)(n.td,{children:["ai",":timeoutms"]}),(0,o.jsx)(n.td,{children:"int"}),(0,o.jsx)(n.td,{children:"timeout (in milliseconds) for AI calls"})]})]})]}),"\n",(0,o.jsxs)(n.p,{children:["Here's an example of pointing it to a local Ollama instance. Note that to get the text in the header of the AI block\nto update, you'll need to set the \"ai",":name","\" key. For ollama, you'll also need to provide something for the\napitoken (even though it is ignored)."]}),"\n",(0,o.jsxs)(n.p,{children:["Here are the ollma open AI compatibility docs: ",(0,o.jsx)(n.a,{href:"https://github.com/ollama/ollama/blob/main/docs/openai.md",children:"https://github.com/ollama/ollama/blob/main/docs/openai.md"})]}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-json",children:'{\n  "ai:*": true,\n  "ai:baseurl": "http://localhost:11434/v1",\n  "ai:name": "llama3.2",\n  "ai:model": "llama3.2",\n  "ai:apitoken": "ollama"\n}\n'})}),"\n",(0,o.jsxs)(n.p,{children:["Note: we set the ",(0,o.jsx)(n.code,{children:"ai:*"}),' key to true to clear all the existing "ai" keys so this config is a clean slate.']}),"\n",(0,o.jsxs)(n.p,{children:["To switch between multiple models, consider ",(0,o.jsx)(n.a,{href:"./presets",children:"adding AI Presets"})," instead."]}),"\n",(0,o.jsx)(n.h3,{id:"how-can-i-connect-to-azure-ai",children:"How can I connect to Azure AI?"}),"\n",(0,o.jsxs)(n.p,{children:["Open your ",(0,o.jsx)(n.a,{href:"./config",children:"config file"})," in Wave using ",(0,o.jsx)(n.code,{children:"wsh editconfig"})," (the config file is normally located\nat ",(0,o.jsx)(n.code,{children:"~/.config/waveterm/settings.json"}),")."]}),"\n",(0,o.jsxs)(n.p,{children:["You'll need to set your ",(0,o.jsx)(n.code,{children:"ai:baseurl"})," to your Azure AI Base URL (do not include query parameters or ",(0,o.jsx)(n.code,{children:"api-version"}),").\nYou'll also need to set ",(0,o.jsx)(n.code,{children:"ai:apitype"})," to ",(0,o.jsx)(n.code,{children:"azure"}),". You can then set the ",(0,o.jsx)(n.code,{children:"ai:model"}),", and ",(0,o.jsx)(n.code,{children:"ai:apitoken"})," appropriately\nfor your setup."]}),"\n",(0,o.jsx)(n.h3,{id:"how-can-i-connect-to-claude",children:"How can I connect to Claude?"}),"\n",(0,o.jsxs)(n.p,{children:["Open your ",(0,o.jsx)(n.a,{href:"./config",children:"config file"})," in Wave using ",(0,o.jsx)(n.code,{children:"wsh editconfig"}),"."]}),"\n",(0,o.jsx)(n.p,{children:"Set these keys:"}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-json",children:'{\n  "ai:*": true,\n  "ai:apitype": "anthropic",\n  "ai:model": "claude-3-5-sonnet-latest",\n  "ai:apitoken": "<your anthropic API key>"\n}\n'})}),"\n",(0,o.jsxs)(n.p,{children:["Note: we set the ",(0,o.jsx)(n.code,{children:"ai:*"}),' key to true to clear all the existing "ai" keys so this config is a clean slate.']}),"\n",(0,o.jsxs)(n.p,{children:["To switch between models, consider ",(0,o.jsx)(n.a,{href:"./presets",children:"adding AI Presets"})," instead."]}),"\n",(0,o.jsx)(n.h3,{id:"how-can-i-see-the-block-numbers",children:"How can I see the block numbers?"}),"\n",(0,o.jsx)(n.p,{children:"The block numbers will appear when you hold down Ctrl-Shift (and disappear once you release the key combo)."}),"\n",(0,o.jsx)(n.h3,{id:"how-do-i-make-a-remote-connection",children:"How do I make a remote connection?"}),"\n",(0,o.jsxs)(n.p,{children:["There is a button in the header. Click the ",(0,o.jsx)("i",{className:"fa-sharp fa-laptop"})," or ",(0,o.jsx)("i",{className:"fa-sharp fa-arrow-right-arrow-left"}),"\nand type the ",(0,o.jsx)(n.code,{children:"[user]@[host]"})," that you wish to connect to."]}),"\n",(0,o.jsx)(n.h3,{id:"on-windows-how-can-i-use-git-bash-as-my-default-shell",children:"On Windows, how can I use Git Bash as my default shell?"}),"\n",(0,o.jsxs)(n.p,{children:["In order to make Git Bash your default shell you'll need to set the configuration variable ",(0,o.jsx)(n.code,{children:"term:localshellpath"}),' to\nthe location of the Git Bash "bash.exe" binary. By default it is located at "C:\\Program Files\\Git\\bin\\bash.exe".\nJust remember in JSON, backslashes need to be escaped. So add this to your ',(0,o.jsx)(n.a,{href:"./config",children:"settings.json"})," file:"]}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-json",children:'    "term:localshellpath": "C:\\\\Program Files\\\\Git\\\\bin\\\\bash.exe"\n'})})]})}function h(e={}){const{wrapper:n}={...(0,i.R)(),...e.components};return n?(0,o.jsx)(n,{...e,children:(0,o.jsx)(d,{...e})}):d(e)}},3023:(e,n,t)=>{t.d(n,{R:()=>a,x:()=>l});var s=t(3696);const o={},i=s.createContext(o);function a(e){const n=s.useContext(i);return s.useMemo((function(){return"function"==typeof e?e(n):{...n,...e}}),[n,e])}function l(e){let n;return n=e.disableParentContext?"function"==typeof e.components?e.components(o):e.components||o:a(e.components),s.createElement(i.Provider,{value:n},e.children)}}}]);